from mock import call
import nose.tools as nt

import ckanext.odsh.tests_tpsh.thumbnail_patches as p
from ckanext.odsh.pdf_to_thumbnail.plugin import ThumbnailPlugin

class TestAfterCreateFrontend(p.WithAfterCreateDataFrontend):

    def setUp(self):
        super(TestAfterCreateFrontend, self).setUp()
        p.mock_action_handler.reset_mock()
        p.mock_action_handler.return_value = self.package_dict

    @p.patch_write_thumbnail_into_package
    @p.patch_create_thumbnail_from_memory
    @p.patch_get_action
    def test_with_data_from_frontend(self, patch_ga, patch_ctfm, patch_wtip):
        ThumbnailPlugin().after_create(self.context, self.resource)
        patch_ctfm.assert_called_once_with(self.package_dict.get('resources')[0], None)
        patch_ga.assert_has_calls([
            call('package_show'),
            call('package_show'),
            call('package_show'),
        ])
        patch_wtip.assert_called_once_with(self.context, 'filename')


class TestAfterCreateAPI(p.WithAfterCreateDataAPI):

    def setUp(self):
        super(TestAfterCreateAPI, self).setUp()
        p.mock_action_handler.reset_mock()
        p.mock_action_handler.return_value = self.package_dict

    @p.patch_write_thumbnail_into_package
    @p.patch_create_thumbnail_from_memory
    @p.patch_get_action
    def test_with_data_from_API_first_resource(self, patch_ga, patch_ctfm, patch_wtip):
        ThumbnailPlugin().after_create(self.context, self.resource)
        patch_ctfm.assert_called_once_with(self.package_dict.get('resources')[0], None)
        patch_ga.assert_has_calls([
            call('package_show'),
            call('package_show'),
            call('package_show'),
        ])
        patch_wtip.assert_called_once_with(self.context, 'filename')
    
    @p.patch_write_thumbnail_into_package
    @p.patch_create_thumbnail_from_memory
    @p.patch_get_action 
    def test_with_data_from_API_second_resource(self, patch_ga, patch_ctfm, patch_wtip):
        p.mock_action_handler.return_value = self.package_dict_second_call
        ThumbnailPlugin().after_create(self.context, self.resource)
        patch_ga.assert_has_calls([
            call('package_show'),
            call('package_show'),
        ])
        patch_ctfm.assert_not_called()
        patch_wtip.assert_not_called()
